#!/usr/bin/env python
# -*- coding: utf8 -*-
import sys, os, dbus, subprocess

from PyQt4 import Qt, QtCore, QtGui, uic

app = QtGui.QApplication (sys.argv)
form_class, base_class = uic.loadUiType ('kflash.ui')

class kflash (QtGui.QWidget, form_class):
    
    lst = None
    str_mkdosfs = "/sbin/mkdosfs"
    str_ext2 = "/sbin/mke2fs"
    str_dd = "/bin/dd"
    trigger = QtCore.pyqtSignal()
    
    def __init__(self, *args):
        super (kflash, self).__init__(*args)        
        self.setupUi (self)
        self.lineEdit.insert("qfflash")
        self.find_devices()
        self.device_path()
        #ищем необходимые консольные утилиты:
        if (os.path.exists(self.str_mkdosfs)):
            self.label_3.setText(self.label_3.text() + QtCore.QString.fromUtf8("Найдена программа mkdosfs.\n"))
            self.comboBox_2.insertItem (0,"fat32")
        else:
            self.label_3.setText(self.label_3.text() + QtCore.QString.fromUtf8("mkdosfs не найдена.(Возможно вам надо установить необходимый пакет)"))
        if (os.path.exists(self.str_ext2)):
            self.label_3.setText(self.label_3.text() + QtCore.QString.fromUtf8("Найдена программа mke2fs.\n"))
            self.comboBox_2.insertItem (1,"ext2")
        else:
            self.label_3.setText(self.label_3.text() + QtCore.QString.fromUtf8("mke2fs не найдена."))
        if (os.path.exists(self.str_dd)):
            self.label_3.setText(self.label_3.text() + QtCore.QString.fromUtf8("Найдена программа dd.\n"))
        else:
            self.label_3.setText(self.label_3.text() + QtCore.QString.fromUtf8("dd не найдена. Полное форматирование не доступно"))
            self.radioButton_2.setEnabled(0)
            
        #connects
        self.connect(self.pushButton_2,QtCore.SIGNAL("clicked ()"),QtGui.qApp,QtCore.SLOT("quit ()"))
        self.connect(self.pushButton,QtCore.SIGNAL("clicked ()"),self.format_flash)
        self.connect(self.pushButton_3,QtCore.SIGNAL("clicked ()"),self.refresh_info)
        self.connect(self.comboBox,QtCore.SIGNAL("activated(int)"),self.device_path)

    def zap_lst(self):
        if self.lst != None:
            lst = self.lst.keys()
            i = 0
            for dev in lst:
                self.comboBox.insertItem (i, dev)
                i = i + 1
    
    #Для выбранного устройства ищем путь (он же раздел) в /dev/blabla
    def device_path(self):
        self.comboBox_3.clear()
        if self.lst.has_key(str(self.comboBox.currentText())):
            lst = self.lst[str(self.comboBox.currentText())]
            i = 0
            for dev in lst:
                self.comboBox_3.insertItem(i,dev)
                i = i + 1

    def refresh_info(self):
        self.comboBox.clear()
        self.find_devices()
        self.device_path()
   
    def format_flash(self):
        rez = QtGui.QMessageBox.warning(self,"kflash",u"Все данные будут уничтожены.\nПеред форматированием отмонтируйте устройство.",QtGui.QMessageBox.Yes|QtGui.QMessageBox.Cancel)
        if  rez == QtGui.QMessageBox.Yes:
            self.setCursor(QtCore.Qt.CursorShape(QtCore.Qt.WaitCursor))
            if self.radioButton.isChecked():
                self.pushButton_2.setEnabled(0)
                self.pushButton.setEnabled(0)
                str_1 = self.sbor()
                for v1 in str_1:
                    self.label_3.setText(self.label_3.text()+v1)
                p = subprocess.Popen(str_1,shell = False, stdout = subprocess.PIPE)
                p.wait()
                lines = p.stdout.readlines()
                for line in lines:
                    self.label_3.setText(line + u"\nВыполнено.")
            elif self.radioButton_2.isChecked():
                self.pushButton_2.setEnabled(0)
                self.pushButton.setEnabled(0)
                str_1 = []
                str_1.append(self.str_dd)
                str_1.append("if=/dev/zero")
                str_1.append("of=" + str(self.comboBox_3.currentText()))
                p = subprocess.Popen(str_1,shell = False,stdout = subprocess.PIPE)
                p.wait()
                lines = p.stdout.readlines()
                for line in lines:
                    self.label_3.setText(self.label_3.text() + line)
                str_1 = self.sbor()
                p = subprocess.Popen(str_1,shell = False,stdout = subprocess.PIPE)
                p.wait()
                lines = p.stdout.readlines()
                for line in lines:
                    self.label_3.setText(self.label_3.text() + line)
            self.label_3.setText(u"Операция выполнена успешно.")
            self.pushButton_2.setEnabled(1)
            self.pushButton.setEnabled(1)
            self.setCursor(QtCore.Qt.CursorShape(QtCore.Qt.ArrowCursor))
        else:
            self.label_3.setText(u"Операция отменена")
            
    def sbor(self):
        str_1 = []
        if self.comboBox_2.currentText() == "fat32":
            str_1.append(self.str_mkdosfs)
            str_1.append("-F32")
            if self.checkBox.isEnabled():
                str_1.append("-n")
                str_1.append("\"" + self.lineEdit.text() + "\"")
            str_1.append(self.comboBox_3.currentText())
        elif self.comboBox_2.currentText() == "ext2":
            str_1.append(self.str_ext2)
            str_1.append("-t ext2")
            if self.checkBox.isEnabled():
                str_1.append("-L " + "\"" + self.lineEdit.text() + "\"")
            str_1.append(self.comboBox_3.currentText())
        return str_1

    def find_devices(self):
        dic = {}
        bus = dbus.SystemBus()
        hal_manager_object = bus.get_object('org.freedesktop.Hal', '/org/freedesktop/Hal/Manager')
        hal_manager_interface = dbus.Interface(hal_manager_object, 'org.freedesktop.Hal.Manager')
        vl = hal_manager_interface.FindDeviceByCapability('volume')
        for udi in vl:
            device = dbus.Interface(bus.get_object("org.freedesktop.Hal",udi),"org.freedesktop.Hal.Device")          
            storage_udi = device.GetProperty ('block.storage_device')
            storage = dbus.Interface(bus.get_object("org.freedesktop.Hal",storage_udi),"org.freedesktop.Hal.Device")
            if storage.GetProperty ('storage.bus') == 'usb':
                mes = storage.GetProperty('storage.vendor') + storage.GetProperty('storage.model')
                if dic.has_key(mes):
                    dic[mes] = dic[mes] + [device.GetProperty('block.device')]
                else:
                    dic[mes] = [device.GetProperty('block.device')]
        self.lst = dic
        self.zap_lst()

form = kflash()
form.show()
sys.exit(app.exec_())